package com.squidder.base.baseLoader.types {
	import com.squidder.base.baseLoader.BaseLoaderProperties;		

	/**
	 * Loaded item is a special case scenario for when an asset
	 * that has been previously loaded in is added into BaseLoader.
	 * @author Jon Reiling
	 */
	public class LoadedItem extends BaseLoaderItem {

		/**
		 * Item constructor.
		 * @param url URL of the item.
		 * @param props Properties, if any, of the item.
		 */
		 public function LoadedItem(url : String, props : BaseLoaderProperties ) {
			super( url , props );
		}
		
		/**
		 * Set the content of the item for access.
		 */
		 public function set content( content : * ) : void {
			
			_content = content;	
		}
	}
}
